/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */
var gc = gc || {};
gc.services = gc.services || {};
var catchedState = '';
var pollingInterval = 3000;
var globalRegisterState = {
  setInProgressFlagToTrue: function () {
    this.inProgress = true;
    //console.log(`${this.name} inprogress flag is set to true`);
    if (this.inProgressTimer) {
      clearTimeout(this.inProgressTimer);
      this.inProgressTimer = null;
    }
  },
  setInProgressFlagToFalse: function () {
    if (this.inProgressTimer) {
      clearTimeout(this.inProgressTimer);
      this.inProgressTimer = null;
    }
    this.inProgressTimer = setTimeout(() => {
      this.inProgress = false;
      //console.log(`${this.name} inprogress flag is set to false`);
    }, 2000);
  },
  data: {
    ic_status_1_reg: {
      name: "ic_status_1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    vgs_vds_stat_reg: {
      name: "vgs_vds_stat_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    ic_status_2_reg: {
      name: "ic_status_2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    rsvd_stat_reg: {
      name: "rsvd_stat_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    ic_ctrl_reg: {
      name: "ic_ctrl_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    brg_ctrl_reg: {
      name: "brg_ctrl_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    drv_ctrl_1_reg: {
      name: "drv_ctrl_1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    drv_ctrl_2_reg: {
      name: "drv_ctrl_2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    drv_ctrl_3_reg: {
      name: "drv_ctrl_3_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    vds_ctrl_1_reg: {
      name: "vds_ctrl_1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    vds_ctrl_2_reg: {
      name: "vds_ctrl_2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    olsc_ctrl_reg: {
      name: "olsc_ctrl_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    uvov_ctrl_reg: {
      name: "uvov_ctrl_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    csa_ctrl_reg: {
      name: "csa_ctrl_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    ic_stat1_reg: {
      name: "ic_stat1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    vds_stat1_reg: {
      name: "vds_stat1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    vds_stat2_reg: {
      name: "vds_stat2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    vgs_stat1_reg: {
      name: "vgs_stat1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    vgs_stat2_reg: {
      name: "vgs_stat2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    ic_stat2_reg: {
      name: "ic_stat2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    ic_stat3_reg: {
      name: "ic_stat3_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    ic_ctrl1_reg: {
      name: "ic_ctrl1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    ic_ctrl2_reg: {
      name: "ic_ctrl2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    brg_ctrl1_reg: {
      name: "brg_ctrl1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    brg_ctrl2_reg: {
      name: "brg_ctrl2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pwm_ctrl1_reg: {
      name: "pwm_ctrl1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pwm_ctrl2_reg: {
      name: "pwm_ctrl2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pwm_ctrl3_reg: {
      name: "pwm_ctrl3_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pwm_ctrl4_reg: {
      name: "pwm_ctrl4_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    idrv_ctrl1_reg: {
      name: "idrv_ctrl1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    idrv_ctrl2_reg: {
      name: "idrv_ctrl2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    idrv_ctrl3_reg: {
      name: "idrv_ctrl3_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    idrv_ctrl4_reg: {
      name: "idrv_ctrl4_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    idrv_ctrl5_reg: {
      name: "idrv_ctrl5_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    idrv_ctrl6_reg: {
      name: "idrv_ctrl6_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    idrv_ctrl7_reg: {
      name: "idrv_ctrl7_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    idrv_ctrl8_reg: {
      name: "idrv_ctrl8_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    idrv_ctrl9_reg: {
      name: "idrv_ctrl9_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    drv_ctrl1_reg: {
      name: "drv_ctrl1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    drv_ctrl2_reg: {
      name: "drv_ctrl2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    drv_ctrl3_reg: {
      name: "drv_ctrl3_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    drv_ctrl4_reg: {
      name: "drv_ctrl4_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    drv_ctrl5_reg: {
      name: "drv_ctrl5_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    drv_ctrl6_reg: {
      name: "drv_ctrl6_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    drv_ctrl7_reg: {
      name: "drv_ctrl7_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    vds_ctrl1_reg: {
      name: "vds_ctrl1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    vds_ctrl2_reg: {
      name: "vds_ctrl2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    vds_ctrl3_reg: {
      name: "vds_ctrl3_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    vds_ctrl4_reg: {
      name: "vds_ctrl4_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    olsc_ctrl1_reg: {
      name: "olsc_ctrl1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    olsc_ctrl2_reg: {
      name: "olsc_ctrl2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    csa_ctrl1_reg: {
      name: "csa_ctrl1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    csa_ctrl2_reg: {
      name: "csa_ctrl2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    csa_ctrl3_reg: {
      name: "csa_ctrl3_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    agd_ctrl1_reg: {
      name: "agd_ctrl1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pdr_ctrl1_reg: {
      name: "pdr_ctrl1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pdr_ctrl2_reg: {
      name: "pdr_ctrl2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pdr_ctrl3_reg: {
      name: "pdr_ctrl3_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pdr_ctrl4_reg: {
      name: "pdr_ctrl4_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pdr_ctrl5_reg: {
      name: "pdr_ctrl5_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pdr_ctrl6_reg: {
      name: "pdr_ctrl6_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pdr_ctrl7_reg: {
      name: "pdr_ctrl7_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pdr_ctrl8_reg: {
      name: "pdr_ctrl8_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pdr_ctrl9_reg: {
      name: "pdr_ctrl9_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pdr_ctrl10_reg: {
      name: "pdr_ctrl10_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    stc_ctrl1_reg: {
      name: "stc_ctrl1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    stc_ctrl2_reg: {
      name: "stc_ctrl2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    stc_ctrl3_reg: {
      name: "stc_ctrl3_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    stc_ctrl4_reg: {
      name: "stc_ctrl4_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    dcc_ctrl1_reg: {
      name: "dcc_ctrl1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pst_ctrl1_reg: {
      name: "pst_ctrl1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    pst_ctrl2_reg: {
      name: "pst_ctrl2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    sgd_stat1_reg: {
      name: "sgd_stat1_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    sgd_stat2_reg: {
      name: "sgd_stat2_reg",
      inProgress: false,
      inProgressTimer: undefined
    },
    sgd_stat3_reg: {
      name: "sgd_stat3_reg",
      inProgress: false,
      inProgressTimer: undefined
    }
  }
}

var setStatusMessage = function () {
  let statusMessage1 = document.querySelector('#statusMessage1');
  let statusMessage2 = document.querySelector('#statusMessage2');
  let vtabContainer = document.querySelector('#ti_widget_vtabcontainer')

  /*if (vtabContainer.selectedIndex == 0) {
    statusMessage1.style.display = "none";
    statusMessage2.removeAttribute('hidden');
    statusMessage2.innerText = `Power the EVM through J2 and connect it to the PC. Then, select a GUI EVM variant`;
  } else if (gc.connectionManager && gc.connectionManager.status === "disconnected") {
    statusMessage1.style.display = "";
    statusMessage2.removeAttribute('hidden');
    statusMessage2.innerText = `Power the EVM through J2 and connect it to the PC.`;
  }*/
}

var appResetFunction = function () {
  let appDataComponent = document.querySelector('#ti_mdbu_custom_appdata');
  appDataComponent._setDeviceConnectionState({
    deviceId: '',
    isConnected: false
  });

  if (gc.connectionManager) {
    gc.connectionManager.disconnect();
    templateObj.$.ti_widget_menubar.productName = originalProductName;
  }
  document.querySelector('#ti_widget_custom_multidevice_appmgr').resetApp();
  updateFileMenuOptionsVisibility(true);
  let registerMapCustomControls = document.querySelector('#ti_custom_registermap_customcontrols');
  if (registerMapCustomControls) {
    registerMapCustomControls.updateNSleepValue(0);
    registerMapCustomControls.updateFaultStatus(0);
  }
};

var updateFileMenuOptionsVisibility = function (isOnLandingPage) {
  let programDeviceMenu = document.querySelector('#FileProgram');
  let loadRegOption = document.querySelector('#load_registers');
  let saveRegOption = document.querySelector('#save_registers');
  let loadGUIRegOption = document.querySelector('#load_gui_register');
  let loadDatasheetRegOption = document.querySelector('#load_datasheet_register');
  let fileMenu = document.querySelector('#ti_widget_filemenu');
  let openScriptingOption = document.querySelector('#scripting');
  let connectionStatusIcon = document.querySelector("#statusBarIcon");

  if (programDeviceMenu) {
    let menuAction = programDeviceMenu.querySelector('#menuAction');
    if (menuAction) {
      menuAction.style.display = isOnLandingPage ? "" : "none";
    }
  }
  /*if (!isOnLandingPage) {
    let statusMessage2 = document.querySelector('#statusMessage2');
    statusMessage2.innerText = `Power the EVM through J2 and connect it to the PC.`;
    return;
  }*/
  if (isOnLandingPage) {
    let statusMessage1 = document.querySelector('#statusMessage1');
    statusMessage1.setAttribute('hidden', true);
  }

  if (fileMenu) {
    fileMenu.style.display = "";
  }

  if (loadRegOption) {
    loadRegOption.style.display = "none";
  }
  if (saveRegOption) {
    saveRegOption.style.display = "none";
  }
  if (loadGUIRegOption) {
    loadGUIRegOption.style.display = "none";
  }
  if (loadDatasheetRegOption) {
    loadDatasheetRegOption.style.display = "none";
  }
  if (openScriptingOption) {
    let menuAction = openScriptingOption.querySelector('#menuAction');
    if (menuAction) {
      menuAction.style.display = "none";
    }
  }
  /*if (connectionStatusIcon) {
    connectionStatusIcon.style.display = "none";
  }*/

}

function _getDeviceName(deviceId) {
  let deviceName = '';
  switch (deviceId) {
    case 6:
    case 8:
    case 10:
      deviceName = 'drv824xs-q1evm';
      break;
    case 7:
    case 9:
    case 11:
      deviceName = 'drv824xh-q1evm';
      break;
    case 24:
    case 26:
      deviceName = 'drv814xs-q1evm';
      break;
    case 25:
    case 27:
      deviceName = 'drv814xh-q1evm';
      break;

    default:
      break;
  }
  return deviceName;
}

/*
 *  Boilerplate code for creating computed data bindings
 */
document.addEventListener('gc-databind-ready', function () {

  var getDeviceObj = function () {
    var deferred = Q.defer();

    setTimeout(function () {
      let deviceName = document.querySelector('#ti_widget_custom_multidevice_appmgr')._deviceNames;

      if((deviceName == "drv824xs-q1evm") || (deviceName == "drv814xs-q1evm"))
      {
        gc.target.access.readValue('gDeviceSpiReg.device_id_reg').then(function(value){
          deferred.resolve(value>>3);
        }).fail(function (reason) {
          deferred.reject(reason);
        });
      }
      else{
        gc.target.access.readValue('gDRV824x').then(function (value) {
          deferred.resolve(value.deviceID);
        }).fail(function (reason) {
          deferred.reject(reason);
        });
      }
    }, 250);

    return deferred.promise;
  }

  var setFirmwareVersionAndOnlineGUILink = function (aboutBox) {
    let settingsPage;
    let appDataComponent = document.querySelector('#ti_mdbu_custom_appdata');
    let revIDText = appDataComponent.revID === undefined || appDataComponent.revID === 0 ? '1.0' : '2.0';

    if (!appDataComponent.deviceConnectionState.isConnected) {
      var str = 'Version of EVM’s Firmware: unknown\nRev Id: unknown';
      aboutBox.appInfoText = str;
      aboutBox.numRowsInAppInfoTextArea = 3;
      return;
    }

    if (appDataComponent.deviceConnectionState.deviceId == 1) { //if deviceId = drv824xs
      settingsPage = document.querySelector('#ti_tile_settings_drv824xs-q1evm');
    }
    if (appDataComponent.deviceConnectionState.deviceId == 2) { //if deviceId = drv824xh
      settingsPage = document.querySelector('#ti_tile_settings_drv824xh-q1evm');
    }
    if (appDataComponent.deviceConnectionState.deviceId == 3) { //if deviceId = drv814xs
      settingsPage = document.querySelector('#ti_tile_settings_drv814xs-q1evm');
    }
    if (appDataComponent.deviceConnectionState.deviceId == 4) { //if deviceId = drv814xh
      settingsPage = document.querySelector('#ti_tile_settings_drv814xh-q1evm');
    }

    if (!settingsPage) {
      return;
    }

    appDataComponent.deviceReadValue('gDRV8x06_Obj').then(function (value) {
      var str = `Version of EVM’s Firmware: ${value.firmwareVersion}\nRev Id: ${revIDText}`;
      aboutBox.appInfoText = str;
      aboutBox.numRowsInAppInfoTextArea = 3;
    });
  }

  var extendAboutBox = function () {
    var aboutBox = document.querySelector('ti-widget-aboutbox');
    if (aboutBox) {
      aboutBox.addEventListener('aboutbox_opening', function (event) {
        aboutBox.appInfoTextHeading = 'Details';
        aboutBox.softwareManifestLink = "docs/manifest.html";
        aboutBox.licenseLink = "docs/license.pdf";

        setFirmwareVersionAndOnlineGUILink(aboutBox);
      });
    }
  };

  var regChangedListener = new gc.databind.IChangedListener();
  var updateDeviceConnectionState = function (oldState, newState) {
    if (newState) {
      getDeviceObj().then(function (deviceObj) {
        let deviceId = deviceObj.deviceID;
        updateDeviceConnectionStateInallComponents(true, deviceId);
      }).fail(function (reason) {
        updateDeviceConnectionStateInallComponents(false);
      })
    } else {
      updateDeviceConnectionStateInallComponents(false);
    }
  };

  var updateDeviceConnectionStateInallComponents = function (state, deviceId) {

    let appDataComponent = document.querySelector('#ti_mdbu_custom_appdata');
    if (state) {
      let deviceName = _getDeviceName(deviceId).toUpperCase();
      templateObj.$.ti_widget_eventlog_view.log("info", deviceName + " connected");
      let statusMessage = document.querySelector('#statusMessage2');
      if (statusMessage) {
        statusMessage.innerText = `Hardware Connected: ${deviceName}`;
      }

      appDataComponent._setDeviceConnectionState({
        isConnecting: false,
        isConnected: true,
        deviceId: deviceId
      });

    } else {
      gc.connectionManager.disconnect();

      /*let statusMessage = document.querySelector('#statusMessage2');
      if (statusMessage) {
        statusMessage.innerText = `Hardware not Connected`;
      }*/
      templateObj.$.ti_widget_eventlog_view.log("info", "EVM disconnected");

      document.querySelector(`#ti_custom_drv824xs-q1evm_homepage`)._deviceConnectionChange(false);
      document.querySelector(`#ti_custom_drv824xh-q1evm_homepage`)._deviceConnectionChange(false);
      document.querySelector(`#ti_custom_drv814xs-q1evm_homepage`)._deviceConnectionChange(false);
      document.querySelector(`#ti_custom_drv814xh-q1evm_homepage`)._deviceConnectionChange(false);

      document.querySelector(`#ti_tile_settings_drv824xs-q1evm`)._deviceConnectionChange(false);
      document.querySelector(`#ti_tile_settings_drv824xh-q1evm`)._deviceConnectionChange(false);
      document.querySelector(`#ti_tile_settings_drv814xs-q1evm`)._deviceConnectionChange(false);
      document.querySelector(`#ti_tile_settings_drv814xh-q1evm`)._deviceConnectionChange(false);
    }
  }

  regChangedListener.onValueChanged = updateDeviceConnectionState.bind(this);
  gc.databind.registry.getBinding('my_model.$target_connected').addChangedListener(regChangedListener);

  // gc.databind.registry.bind('widget.ti_tile_settings_824xs.busVoltageValue2', 'widget.ti_tile_settings_824xs.fluxValue2', null, undefined);

  // gc.databind.registry.bind('widget.ti_tile_settings_824xs.systemEnableValue', 'gMotorVars.Flag_enableSys', null, undefined);
  // gc.databind.registry.bind('widget.ti_tile_settings_824xs.busVoltageValue2', 'gMotorVars.Flux_VpHz', null, undefined);
  // gc.databind.registry.bind('widget.ti_tile_settings_824xs.fluxValue2', 'gMotorVars.VdcBus_kV', null, undefined);

  /*
   *   Add custom computed value databindings here, using the following method:
   *
   *   function gc.databind.registry.bind(targetBinding, modelBinding, [getter], [setter]);
   *
   *   param targetBinding - single binding string or expression, or array of binding strings for multi-way binding.
   *   param modelBinding - single binding string or expression, or array of binding strings for multi-way binding.
   *   param getter - (optional) - custom getter function for computing the targetBinding value(s) based on modelBinding value(s).
   *   param setter - (optional) - custom setter function for computing the modelBinding value(s) based on targetBinding value(s).
   */

  // For example, a simple computed values based on simple expression
  // gc.databind.registry.bind('widget.id.propertyName', "targetVariable == 1 ? 'binding is one' : 'binding is not one'");

  // Or a custom two-way binding with custome getter and setter functions.  (setter is optional)  (getter only indicates one-way binding)
  // gc.databind.registry.bind('widget.id.propertyName', "targetVariable", function(value) { return value*5/9 + 32; }, function(value) { (return value-32)*9/5; });

  // Event 1 to n bindings
  /*
  gc.databind.registry.bind('widget.date.value',
      // dependant bindings needed in order to compute the date, in name/value pairs.
      {
          weekday: 'widget.dayOfWeek.selectedText',
          day: 'widget.dayOfMonth.value',
          month: 'widget.month.selectedText',
          year: 'widget.year.value'
      },
      // getter for date computation
      function(values)
      {
          // compute and return the string value to bind to the widget with id 'date'
          return values.weekday + ', ' + values.month + ' ' + values.day + ', ' + values.year;
      }
  );
  */

  /*gc.autoDetectPortsFilter = function (transport, ports, info) {
    return ports.filter(function (port) {
      return port.manufacturer === "FTDI";
    });
  }
  extendAboutBox();*/

  gc.connectionManager.addEventListener('status-changed', statusChangeHdlr);
});

function statusChangeHdlr() {
  if (catchedState == gc.connectionManager.status) {
    return;
  }
  catchedState = gc.connectionManager.status;
  console.log('Status', gc.connectionManager.status);
  let appDataComponent = document.querySelector('#ti_mdbu_custom_appdata');

  if (gc.connectionManager.status === "connecting") {
    appDataComponent._setDeviceConnectionState({
      isConnecting: true,
      isConnected: false
    });
  }
  if (gc.connectionManager.status === "disconnecting" || gc.connectionManager.status === "disconnected") {
    appDataComponent._setDeviceConnectionState({
      isConnecting: false,
      isConnected: false
    });
    // let deviceName = _getDeviceName(this.deviceId);
    // let statusMessage = document.querySelector('#statusMessage1');
    //   if(statusMessage){
    //       statusMessage.innerText = deviceName + " is Connected";
    //   }
  }

  if (gc.connectionManager.status === "connected" || gc.connectionManager.status == "disconnected") {
    setStatusMessage();
  }
}

function disableRegAutoRead() {
  let registerLoadPopup = document.querySelector('#ti_load_register_popup');
  registerLoadPopup._showPopup();
  window.trapPolling = true;
  setTimeout(function enableRegAutoRead() {
    if( gc.connectionManager.status === "disconnected" ) {
      commQueue.splice(0, commQueue.length);
    }
    if(commQueue.length === 0) {
      let registerLoadPopup = document.querySelector('#ti_load_register_popup');
      registerLoadPopup._closePopup();
      window.trapPolling = false;
    } else {
      setTimeout(enableRegAutoRead, 3000);
    }
  }, 3000);
}

function browseAndSaveCFile(data, callback) {
  var chooser = document.querySelector("#saveCFile");
  chooser.value = null;
  chooser.addEventListener("change", function changeEvtListner(evt) {
    var filePath = this.value;
    chooser.nwsaveas = filePath;
    gc.File._saveFile(filePath, data, callback);
    chooser.removeEventListener("change", changeEvtListner, false);
  }, false);
  chooser.click();
}

function getRegInfoForCfile() {
  var selectedDevice = document.querySelector('#ti_widget_custom_multidevice_appmgr')._deviceNames;
  var genDevName;
  genDevName = 'DRV814xs';
  var result = '';
  var regBlocks = document.querySelector('#ti_widget_register_page').regBlocks;
  for ( var regBlockItem of regBlocks ) {
    for ( var regItem of regBlockItem.registers) {
      var addr = regItem.addr.toString(16);
      var addr = addr.length < 2 ? '0' + addr: addr;
      result = result + '\n#define ' + regItem.name + '_' + genDevName +'        (uint8_t)(0x' + addr + ')';
    }
  }
  result = result + '\n\n\n';
  var regBlocks = document.querySelector('#ti_widget_register_page').regBlocks;
  for ( var regBlockItem of regBlocks ) {
    for ( var regItem of regBlockItem.registers) {
      if (regItem.mode === 'RW') {
        result = result + '\nSPI_writeRegister(' + regItem.name + '_' + genDevName + ', (uint16_t) ' + regItem.value + ')';
      } else {
        var isRWmode = false;
        for( var fieldItem of regItem.fields) {
          if(fieldItem.mode === 'RW') {
            isRWmode = true;
            break;
          }
        }
        if(isRWmode) {
          result = result + '\nSPI_writeRegister(' + regItem.name + '_' + genDevName + ', (uint16_t) ' + regItem.value + ')';
        }
      }
    }
  }
  return result;
}

function saveCTypeFile() {
  var str = getRegInfoForCfile();
  if (gc.desktop.isDesktop()) {
    browseAndSaveCFile(str, function (result, errorInfo) {
      if (errorInfo) {
        console.log("error", "Error saving C file: " + errorInfo.message);
      } else if ((result) && (result.localPath)) {
        console.log("info", "C file saved to " + result.localPath);
      }
    }.bind(this));
  } else {
    var blob = new Blob([str], {
      type: 'text/plain;charset=utf-8'
    });
    saveAs(blob, 'regInfo.c'); // Calls FileSaver.js global function saveAs
    console.log("info", "regInfo.c file downloaded");
  }
}

/*
 *  Boilerplate code for creating custom actions
 */
document.addEventListener('gc-nav-ready', function () {
  /*
   *   Add custom actions for menu items using the following api:
   *
   *   function gc.nav.registryAction(id, runable, [isAvailable], [isVisible]);
   *
   *   param id - uniquely identifies the action, and should correspond to the action property of the menuaction widget.
   *   param runable - function that performs the custom action.
   *   param isAvailable - (optional) - function called when the menu action is about to appear.  Return false to disable the action, or true to enable it.
   *   param isVisible - (optional) - function called when the menu action is about to appear.  Return false to hide the action, or true to make it visible.
   */

  // For example,
  // gc.nav.registerAction('myCustomCloseAction', function() { window.close(); }, function() { return true; }, function() { return true; });

  // Alternatively, to programmatically disable a menu action at any time use:
  // gc.nav.disableAction('myCustomCloseAction);    then enable it again using:  gc.nav.enableAction('myCustomCloseAction');

  gc.nav.registerAction('show_introduction', function () {
    if ((templateObj) && (templateObj.$)) {
      templateObj.$.ti_widget_vtabcontainer.selectedIndex = 0;
      templateObj.$.ti_widget_menuitem.hideFullMenu();
    }
  }, function () {
    return true;
  }, function () {
    return true;
  });
  gc.nav.registerAction('show_registers', function () {
    if ((templateObj) && (templateObj.$)) {
      templateObj.$.ti_widget_vtabcontainer.selectedIndex = 1;
      templateObj.$.ti_widget_menuitem.hideFullMenu();
    }
  }, function () {
    return true;
  }, function () {
    return true;
  });
  gc.nav.registerAction('show_motor_control', function () {
    if ((templateObj) && (templateObj.$)) {
      templateObj.$.ti_widget_vtabcontainer.selectedIndex = 2;
      templateObj.$.ti_widget_menuitem.hideFullMenu();
    }
  }, function () {
    return true;
  }, function () {
    return true;
  });

  gc.nav.registerAction('load_registers', function () {
    disableRegAutoRead();
    if ((templateObj) && (templateObj.$)) {
      gc.File.browseAndLoad(null, {
        bin: false
      }, function (contents, properties) {
        var regData = null;
        try {
          regData = JSON.parse(contents);
          if (regData) {
            templateObj.setRegisterData(regData);
            templateObj.$.ti_widget_eventlog_view.log("info", "Load Registers: loaded from :" + properties.localPath);
          }
        } catch (ex) {
          templateObj.logMsgAndNotify("error", "Load Registers: Could not parse file:" + ex, false, true);
        }

      });
    }
  }, function () {
    return true;
  }, function () {
    return true;
  });

  gc.nav.registerAction('load_gui_register', function () {
    disableRegAutoRead();
    if ((templateObj) && (templateObj.$)) {
      var filePath = "app/config/guiregs.json";
      var callback = function (contents) {
        try {
          if (contents) {
            templateObj.setRegisterData(contents);
            //templateObj.$.ti_widget_eventlog_view.log("info", "Load Registers: loaded from :" + properties.localPath);
          }
        } catch (ex) {
          templateObj.logMsgAndNotify("error", "Load Registers: Could not parse file:" + ex, false, true);
        }
      }

      gc.fileCache.readJsonFile(filePath).then(callback);
    }
  }, function () {
    return true;
  }, function () {
    return true;
  });

  gc.nav.registerAction('load_datasheet_register', function () {
    disableRegAutoRead();
    if ((templateObj) && (templateObj.$)) {
      var filePath = "app/config/datasheetregs.json";
      var callback = function (contents) {
        try {
          if (contents) {
            templateObj.setRegisterData(contents);
            //templateObj.$.ti_widget_eventlog_view.log("info", "Load Registers: loaded from :" + properties.localPath);
          }
        } catch (ex) {
          templateObj.logMsgAndNotify("error", "Load Registers: Could not parse file:" + ex, false, true);
        }
      }

      gc.fileCache.readJsonFile(filePath).then(callback);
    }
  }, function () {
    return true;
  }, function () {
    return true;
  });

  var saveText = function (fname, text, mime) {
    var blob = new Blob([text], {
      type: mime
    });
    saveAs(blob, fname);
    return false;
  }
  gc.nav.registerAction('save_registers', function () {
    if ((templateObj) && (templateObj.$)) {
      var regData = templateObj.getRegisterData();
      var regDataJson = JSON.stringify(regData);
      if (gc.desktop.isDesktop()) {
        gc.File.browseAndSave(regDataJson, 'regs.json', '*.json', function (result, errorInfo) {
          if (errorInfo) {
            templateObj.logMsgAndNotify("error", "Save Registers: " + errorInfo, false, true);
          } else if ((result) && (result.localPath)) {
            templateObj.$.ti_widget_eventlog_view.log("info", "Save Registers: saved to " + result.localPath);
          }

        });
      } else {
        saveText("regs.json", regDataJson, 'text/plain;charset=utf-8')
        templateObj.$.ti_widget_eventlog_view.log("info", "Save Registers: regs.json file downloaded");
      }
      saveCTypeFile();
    }
  }, function () {
    return true;
  }, function () {
    return true;
  });

  gc.nav.registerAction('save_registers_as', function () {
    if ((templateObj) && (templateObj.$)) {
      var regData = templateObj.getRegisterData();
      var regDataJson = JSON.stringify(regData);
      if (gc.desktop.isDesktop()) {
        gc.File.browseAndSave(regDataJson, 'regs.json', '*.json', function (result, errorInfo) {
          if (errorInfo) {
            templateObj.logMsgAndNotify("error", "Save Registers As: " + errorInfo, false, true);
          } else if ((result) && (result.localPath)) {
            templateObj.$.ti_widget_eventlog_view.log("info", "Save Registers As: saved to " + result.localPath);
          }
        });
      } else {
        saveText("regs.json", regDataJson, 'text/plain;charset=utf-8')
        templateObj.$.ti_widget_eventlog_view.log("info", "Save Registers: regs.json file downloaded");
      }
    }
  }, function () {
    return true;
  }, function () {
    return true;
  });

  gc.nav.registerAction('open_log_pane', function () {
    if ((templateObj) && (templateObj.$)) {
      templateObj.$.ti_widget_eventlog_view.openView();
    }
  }, function () {
    return true;
  }, function () {
    return true;
  });

  gc.nav.registerAction('open_scripting_window', function () {
    window.open('app/scripting.html', '_evm_scripting');
  }, function () {
    return true;
  }, function () {
    return true;
  });
});

/*
 *  Boilerplate code for working with components in the application gist
 */


var initComplete = false;
var templateObj;
var registerModel;
var originalProductName = "";

// Wait for DOMContentLoaded event before trying to access the application template
var init = function () {
  templateObj = document.querySelector('#template_obj');

  // Wait for the template to fire a dom-change event to indicate that it has been 'stamped'
  // before trying to access components in the application.
  templateObj.addEventListener('dom-change', function () {
    if (initComplete) return;
    this.async(function () {
      initComplete = true;
      console.log("Application template has been stamped.");
      templateObj.$.ti_widget_toast.hideToast();
      templateObj.$.ti_widget_eventlog_view.log("info", "Application started.");
      registerModel = Polymer.dom(document).querySelector('ti-model-register');
      if (registerModel) {
        registerModel.addEventListener("usbHidModelReceivingData", function (event) {
          templateObj.logMsgAndNotify("debug", "Receiving data from target.", false, false);
        });
      } else {
        console.log("no ti-model-register component found in this application!")
      }

      // Now that the template has been stamped, you can use 'automatic node finding' $ syntax to access widgets.
      // e.g. to access a widget with an id of 'widget_id' you can use templateObj.$.widgetId

      // open the eventlog viewer when the user clicks on the book icon in the status bar:
      templateObj.$.ti_widget_eventlog_view.closeView(); // ensure that view states are in sync with application
      templateObj.$.ti_widget_statusbar.addEventListener("appiconclicked", function (event) {
        templateObj.$.ti_widget_eventlog_view.toggleView();
      });

      // Expand vtabcontainer nav bar when user clicks on menu icon or 'Menu' label
      templateObj.toggleMenu = function (event) {
        templateObj.$.ti_widget_vtabcontainer.isExpanded = !templateObj.$.ti_widget_vtabcontainer.isExpanded;
      };
      templateObj.$.ti_widget_icon_button_menu.addEventListener('click', templateObj.toggleMenu);
      templateObj.$.ti_widget_label_menu.addEventListener('click', templateObj.toggleMenu);

      // called when the user clicks the Write Register button:
      templateObj.writeReg = function (event) {
        var detailsObj = event.detail;
        templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);

      };

      // called when the user clicks the Read Register button:
      templateObj.readReg = function (event) {
        var detailsObj = event.detail;
        templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
      }

      // called when the user clicks the Read All Registers button:
      templateObj.readRegs = function (event) {
        var detailsObj = event.detail;
        templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
      }

      // called when the user changes the immediate / deferred mode
      templateObj.updateModeChanged = function (event) {
        var detailsObj = event.detail;
        templateObj.$.ti_widget_eventlog_view.log("info", "request to change update mode to " + detailsObj.mode.label);
      }

      // called when the user changes the auto read refresh rate
      templateObj.autoReadConfigChanged = function (event) {
        var detailsObj = event.detail;
        templateObj.$.ti_widget_eventlog_view.log("info", "request to change automatic read interval to " + detailsObj.autoRead.label);
      };


      if (templateObj.$.ti_widget_register_page) {
        // demo of handling when the user clicks the Write Register button
        templateObj.$.ti_widget_register_page.addEventListener("write_reg", templateObj.writeReg);
        templateObj.$.ti_widget_register_page.addEventListener("read_reg", templateObj.readReg);
        templateObj.$.ti_widget_register_page.addEventListener("read_regs", templateObj.readRegs);
        templateObj.$.ti_widget_register_page.addEventListener("update_mode_changed", templateObj.updateModeChanged);
        templateObj.$.ti_widget_register_page.addEventListener("auto_read_config_changed", templateObj.autoReadConfigChanged);
      }

      var usbHidService = gc.services['ti-service-usbhid'];
      if (usbHidService) {
        usbHidService.addEventListener('usbHidError', function (event) {
          var detailsObj = event.detail;
          templateObj.logMsgAndNotify("error", detailsObj.info + ": " + detailsObj.error, false, true);
        })
      }

      templateObj.getRegisterData = function () {
        var regData = {
          signature: "oneui-register-data",
          data: []
        }
        var regBlocks = templateObj.$.ti_widget_register_page.regBlocks;
        for (var i = 0; i < regBlocks.length; i++) {
          var registersData = [];
          for (var r = 0; r < regBlocks[i].registers.length; r++) {
            var reg = regBlocks[i].registers[r];
            var regName = reg.name.toLowerCase();
            regName = regName.replace(/\&/g, "_");
            var item = {
              idx: r,
              id: regName,
              value: reg.value
            }
            registersData.push(item);
          }
          regData.data.push(registersData);
        }
        var strJson = JSON.stringify(regData);
        return strJson;
      };

      templateObj.setRegisterData = function (strJson) {
        var regData = JSON.parse(strJson);
        var ok = true;
        var regBlocks = templateObj.$.ti_widget_register_page.regBlocks;
        for (var b = 0; b < regBlocks.length; b++) {
          var registersData = [];
          for (var r = 0; r < regBlocks[b].registers.length; r++) {
            var reg = regBlocks[b].registers[r];
            var regName = reg.name.toLowerCase();
            regName = regName.replace(/\&/g, "_");
            item = regData.data[b][r];
            if (item.id === regName) {
              reg.value = item.value;
              var intValue = gc.utils.getValueFromHexString("" + reg.value);
              templateObj.$.ti_widget_register_page.writeValueToTargetRegister(intValue, null, b, r);
            } else {
              var msg = "load registers failed: register name mismatch (" + item.id + " does not match " + regName + ")";
              templateObj.logMsgAndNotify("warning", msg, false, true);
            }
          }
        }
      };

      templateObj.showToastMsg = function (msgType, msg, durationInSeconds) {
        templateObj.$.ti_widget_toast.hideToast();
        templateObj.$.ti_widget_toast.message = msg;
        switch (msgType.toLowerCase()) {
          case "error":
            templateObj.$.ti_widget_toast.iconName = "error";
            templateObj.$.ti_widget_toast.backgroundColor = "red";
            break;
          case "warning":
            templateObj.$.ti_widget_toast.iconName = "warning";
            templateObj.$.ti_widget_toast.backgroundColor = "orange";
            break;
          default:
            templateObj.$.ti_widget_toast.iconName = "check";
            templateObj.$.ti_widget_toast.backgroundColor = "teal";
            break;
        }
        templateObj.$.ti_widget_toast.duration = +durationInSeconds;
        templateObj.$.ti_widget_toast.showToast();
        console.log("toast msg [" + msgType + "]: " + msg);
      };

      templateObj.logMsgAndNotify = function (msgType, msg, showInStatusBar, showInToast) {
        var iconName = templateObj.$.ti_widget_eventlog_view.iconForItem(msgType);
        if (showInStatusBar) {
          var statusBar = gc.services['ti-widget-statusbar'];
          if (statusBar) {
            statusBar.statusString3 = msg;
            statusBar.setIcon(iconName);
          }
        }
        if (showInToast) {
          templateObj.showToastMsg(msgType, msg, 4);
        }
        templateObj.$.ti_widget_eventlog_view.log(msgType, msg);
      };
      /* Demo of how to select a board by clicking on a custom button (e.g. with ti_widget_multidevice_app_mgr hidden):

      templateObj.selectBoard = function(event){
          var targetId = event.currentTarget.id;
          var button = document.querySelector('#'+targetId);
          templateObj.$.ti_widget_menubar.productName = button.label;
          var lcBoardName = button.label.toLowerCase().trim();
          templateObj.$.ti_widget_multidevice_app_mgr.selectedBoard = lcBoardName;
      };
      templateObj.$.ti_widget_button_board1.addEventListener('click',templateObj.selectBoard);
      templateObj.$.ti_widget_button_board2.addEventListener('click',templateObj.selectBoard);
      */

      /* Demo of how to open user guide documents in response to the user pressing an icon button:

      templateObj.openLinkOnClick = function(urlToOpen, event){
          window.open(urlToOpen);
      };
      templateObj.$.ti_widget_icon_button_userguide1.addEventListener('click',templateObj.openLinkOnClick.bind(templateObj,'app/assets/collaterals/DRV8304x_EVM_GUI_User_Guide.pdf'));
      templateObj.$.ti_widget_icon_button_userguide2.addEventListener('click',templateObj.openLinkOnClick.bind(templateObj,'app/assets/collaterals/DRV8304x_EVM_Sensored_User_Guide.pdf'));
      templateObj.$.ti_widget_icon_button_userguide3.addEventListener('click',templateObj.openLinkOnClick.bind(templateObj,'app/assets/collaterals/DRV8304x_EVM_Sensorless_User_Guide.pdf'));
          */
      originalProductName = templateObj.$.ti_widget_menubar.productName;

      window.addEventListener('go_to_landing_page', appResetFunction);

      window.addEventListener('app_reset', function (event) {
        let vtabContainer = document.querySelector('#ti_widget_vtabcontainer');
        let appDataComponent = document.querySelector('#ti_mdbu_custom_appdata');
        if (!appDataComponent.deviceConnectionState.isConnected) {
          appResetFunction();
          return;
        }

        let selectedState = document.querySelector('#ti_widget_custom_multidevice_appmgr')._deviceNames;
        if (vtabContainer.selectedIndex == 1) {
          let home = document.querySelector(`#ti_custom_` + selectedState + `_homepage`);
          home._showBackConfirmPopup();
        } else if (vtabContainer.selectedIndex == 2) {
          let registerPopup = document.querySelector('#ti_confirmback_popup');
          registerPopup._showPopup();
        } else if (vtabContainer.selectedIndex == 3) {
          let settings = document.querySelector(`#ti_tile_settings_` + selectedState);
          settings._showBackConfirmPopup();
        } else if (vtabContainer.selectedIndex == 4) {
          let settings = document.querySelector(`#ti_tile_smartgatedrive_` + selectedState);
          settings._showBackConfirmPopup();
        } else if (vtabContainer.selectedIndex == 5) {
          let collateral = document.querySelector(`#ti_collateral_global_` + selectedState);
          collateral._showBackConfirmPopup();
        }
      })

      window.addEventListener('DOMSubtreeModified', (status) => {
        statusDialog = document.querySelector('#statusLabel');
        if (statusDialog.label == "Error configuring Debug Server: error=Failed to connect to MSP430F2617 device: Please unplug your hardware, then plug it back in and try again" ||
          statusDialog.label == "Error configuring Debug Server: error=Failed to connect to MSP430F2617 device: Please unplug your MSP430F2617, then plug it back in and try again") {
          statusDialog.label = "Error: Make sure the MSP-FET tool is connected. If it is, reconnect it to both EVM and the PC."
        }
      })

      document.addEventListener('vtab_click', function (event) {
        let selectedState = document.querySelector('#ti_widget_custom_multidevice_appmgr')._deviceNames;
        let home = document.querySelector(`#ti_custom_` + selectedState + `_homepage`);
        let settings = document.querySelector(`#ti_tile_settings_` + selectedState);
        let collateral = document.querySelector(`#ti_collateral_global_` + selectedState);
        let registerPopup = document.querySelector('#ti_confirmback_popup');

        home._closeConfirmPopup();
        settings._closeConfirmPopup();
        collateral._closeConfirmPopup();
        registerPopup._closePopup();
      });

      var customDeviceManger = document.querySelector('#ti_widget_custom_multidevice_appmgr');
      if (customDeviceManger) {
        customDeviceManger.addEventListener('device_selected', function (event) {

          if (gc.connectionManager) {
            gc.connectionManager.connect();
          }
          updateFileMenuOptionsVisibility(false);
        });

      };

      updateFileMenuOptionsVisibility(true);

      templateObj.$.ti_widget_vtabcontainer.addEventListener("selected_tab_changed", function (event) {
        let paperTabs = templateObj.$.ti_widget_vtabcontainer.querySelectorAll('paper-tabs');
        for (let paperTab of paperTabs) {
          let selectedValue = paperTab.selected;
          paperTab.selected = undefined;
          paperTab.selected = selectedValue;
        }
      });

    }, 1);

    const serialIO = document.querySelector("#serialIO");
    serialIO.defaultBaudRate = 115200;

    var readRegisterButton = document.querySelector("#read_register");
    if (readRegisterButton) {
      readRegisterButton.disabled = true;
    }

    var readAllRegisterButton = document.querySelector("#read_all_registers");
    if (readAllRegisterButton) {
      readAllRegisterButton.disabled = true;
    }

    setStatusMessage();

    templateObj.$.ti_widget_vtabcontainer.addEventListener("selected_tab_changed", function (event) {
      setStatusMessage();
    });

    window.addEventListener("cancelBtnClicked", function (event) {
      setStatusMessage();
    });

    window.addEventListener("programDownloadComplete", function (event) {
      setStatusMessage();
    });
  });

};

templateObj = document.querySelector('#template_obj');
if (templateObj) {
  init();
} else {
  document.addEventListener('DOMContentLoaded', init);
}